#!/usr/bin/ksh
# les disques sources et destination sont de meme taille !!!!!!!!!!!!!!!!!!
##################################################################################################
### usage : buildScriptVXVM.ksh " fichier contenant le vxprint du DG a migrer " " baie " <Controleur > <Target> <device depart>###
##################################################################################################




#construction des scripts pour labeliser les disks, pour formater les disques au format VX et pour inserer les disques dans VM
insertdisk()
{
nbDisk=$nbDsk

if [ ! -f script_migration/label.txt ]
then
   echo "label">script_migration/label.txt
fi
if [ ! -f script_migration/labelize_disks.ksh ]
then
      echo "#!/usr/bin/ksh -x "> script_migration/labelize_disks.ksh
      echo "cat format.txt | while read dsk" >> script_migration/labelize_disks.ksh
      echo "do" >> script_migration/labelize_disks.ksh
      echo "format -d \$dsk -f label.txt" >> script_migration/labelize_disks.ksh
      echo "done">> script_migration/labelize_disks.ksh
fi
echo "vxdctl enable" >> script_migration/labelize_disks.ksh

if  [ ! -f script_migration/insertDisk.ksh ]
then
        echo "#!/usr/bin/ksh -x\n" > script_migration/insertDisk.ksh
        echo "#MODIFIER LES CXTYDZ\n" >> script_migration/insertDisk.ksh
fi
echo "\n#DG "$dg >> script_migration/insertDisk.ksh

if  [ ! -f script_migration/vxdisksetup.ksh ]
then
        echo "#!/usr/bin/ksh -x\n" > script_migration/vxdisksetup.ksh
fi

while [ $nbDisk -gt 0 ]
do
        length=`echo $nbDisk| wc -m`
        length=`expr $length - 2`
        i=`echo $nbDsk - $nbDisk + 1 |bc -l `
        if [ $length -eq 0 ]
        then
                disk[$i]=`printf "%s_%s_0%d" $baie $dg $nbDisk `
                disk_inv[$nbDisk]=`printf "$disk_inv %s_%s_0%d" $baie $dg $nbDisk `
        else
                disk[$i]=`printf "%s_%s_%d $disk" $baie $dg $nbDisk `
                disk_inv[$nbDisk]=`printf "%s_%s_%d" $baie $dg $nbDisk `
        fi
        nbDisk=`expr $nbDisk - 1`
done

for i in ${disk_inv[*]}
do
        echo vxdg -g $dg adddisk $i"=c${ctrl}t${target}d$dev" >> script_migration/insertDisk.ksh
        if [ $Flag_dev -eq 1 ]
        then
            echo "c${ctrl}t${target}d$dev" >> script_migration/format.txt
            echo "/etc/vx/bin/vxdisksetup -if c${ctrl}t${target}d$dev" >> script_migration/vxdisksetup.ksh
            dev=`echo $dev + 1 |bc -l `
        fi
done

}

#creation du script pour le mirroring des DG (mirroring en parralelle)
mirrordg ()
{


if  [ ! -d "script_migration/mirror" ]
then
    mkdir script_migration/mirror
fi

mirrorfile=script_migration/mirror/mirror_$dg.ksh
mirror_file=script_migration/mirror.ksh
if [ ! -f $mirror_file ]
then
        echo "#!/usr/bin/ksh -x\n" >$mirror_file
fi

echo "./mirror/mirror_$dg.ksh"  >>$mirror_file



####################################
###construction  du script miroir###
####################################

if  [ ! -f $mirrorfile ]
then
        echo "#!/usr/bin/ksh -x\n" > $mirrorfile
fi

echo "\n#DG "$dg >> $mirrorfile



for v in `cat $dgfile| grep  '^v' |awk '{print $2}'`
do

        echo vxassist -g $dg mirror $v ${disk[*]} layout=nostripe "&"   >> $mirrorfile

done

}


#creation des scripts de mirroring pour les GROS DG > 15 disk
mirrorbigdg()
{
if  [ ! -d "script_migration/mirror" ]
then
    mkdir script_migration/mirror
fi

mirrorfile=script_migration/mirror/mirror1_$dg.ksh
mirrorfile2=script_migration/mirror/mirror2_$dg.ksh
mirror_file=script_migration/mirror.ksh
if [ ! -f $mirror_file ]
then
        echo "#!/usr/bin/ksh -x\n" >$mirror_file
fi
echo "nohup mirror/mirror1_$dg.ksh 2>&1 > mirror/mirror1_$dg.log &" >> $mirror_file
echo "nohup mirror/mirror2_$dg.ksh 2>&1 > mirror/mirror2_$dg.log &" >> $mirror_file
if  [ ! -f $mirrorfile ]
then
        echo "#!/usr/bin/ksh -x\n" > $mirrorfile
fi
if  [ ! -f $mirrorfile2 ]
then
        echo "#!/usr/bin/ksh -x\n" > $mirrorfile2
fi

echo "date">> $mirrorfile
echo "date">> $mirrorfile2
chmod +x $mirrorfile $mirrorfile2
echo "\n#DG "$dg >> $mirrorfile
echo "\n#DG "$dg >> $mirrorfile2
flag=0
for v in `cat $dgfile| grep  '^v' |awk '{print $2}'`
do

 if [ $flag -eq 0 ]
 then
    echo vxassist -g $dg mirror $v ${disk[*]} layout=nostripe   >> $mirrorfile
    echo sleep 5  >> $mirrorfile
    flag=1
 else
    echo vxassist -g $dg mirror $v ${disk_inv[*]} layout=nostripe   >> $mirrorfile2
    echo sleep 5  >> $mirrorfile2
    flag=0
 fi

done
echo "date">> $mirrorfile
echo "date">> $mirrorfile2
echo "echo FIN DU SCRIPT $mirrorfile"  >> $mirrorfile
echo "echo FIN DU SCRIPT $mirrorfile2"  >> $mirrorfile2

}


rmdisk()
{

####################################
###construction  du script rmDisk###
####################################

if  [ ! -f script_migration/rmDisk.ksh ]
then
        echo "#!/usr/bin/ksh -x\n" > script_migration/rmDisk.ksh
fi

echo "#DG "$dg >> script_migration/rmDisk.ksh

for dm in `cat $dgfile| grep -w "dm"|awk '{print $2}'`
do
  echo vxdg -g $dg rmdisk $dm >> script_migration/rmDisk.ksh
done

for dsk in `cat $dgfile| grep -w "dm"|awk '{print $3}'`
do
  echo vxdisk rm  $dsk>> script_migration/rmDisk.ksh
done
echo "\n" >> script_migration/rmDisk.ksh

}

rmplex()
{

####################################
###construction  du script rmplex###
####################################
if  [ ! -f script_migration/rmPlex.ksh ]
then
        echo "#!/usr/bin/ksh -x\n" > script_migration/rmPlex.ksh
fi

echo "\n#DG "$dg >> script_migration/rmPlex.ksh

for pl in `cat $dgfile| grep -w "pl"|awk '{print $2}'`
do
  echo vxplex -g $dg -o rm dis $pl >> script_migration/rmPlex.ksh
done
}



if [  $# -lt 2 ]
then
        echo "usages : buildScriptVXVM.ksh \"fichier contenant le vxprint du DG a migrer \"  \"baie\" <ctrl> <target> <device debut>"
        exit
fi
if  [ ! -f $1 ]
then
        echo "Le fichier " $1 " n'existe pas "
        exit
fi

if  [ ! -d "script_migration" ]
then
        mkdir script_migration
fi

dgfile=$1
dg=`cat $dgfile | grep '^dg'|awk '{print $2}'`
nbDsk=`cat $dgfile | grep '^dm'| wc -l`
baie=`echo $2  | awk '{ print substr($1,0,3) }'`
ctrl=$3
target=$4
dev=$5

if [ $# -lt 3 ]
then
        ctrl=X
fi
if [ $# -lt 4 ]
then
        target=Y
fi

Flag_dev=1
if [ $# -lt 5 ]
then
        dev=Z
        Flag_dev=0
fi

insertdisk
if [ $nbDsk -gt 10 ]
then
        mirrorbigdg
else
        mirrordg
fi
rmplex
rmdisk

chmod +x script_migration/*
chmod +x $mirrorfile


echo Nom du DG : $dg
echo BAIE : $baie
echo Nombre de disque $nbDsk
echo Nombre de volume `cat $dgfile | grep '^v'|wc -l`
echo disk suivant = C${ctrl}T${target}D${dev}
echo Fichier pour labelizer les disques : script_migration/labelize_disks.ksh
echo Fichier pour formater les disques VXVM : script_migration/vxdisksetup.ksh
echo Fichier insertion disque : script_migration/insertDisk.ksh
echo Fichier mirroir : script_migration/mirror.ksh
echo Fichier suppresion du mirror : script_migration/rmPlex.ksh
echo Fichier suppresion des anciens disques : script_migration/rmDisk.ksh

echo ordre d utilisation des scripts"\n\n" >script_migration/README


echo 1.Labelisation des disques >> script_migration/README
echo ./labelize_disks.ksh"\n\n" >> script_migration/README

echo 2.integration dans VXVM >> script_migration/README
echo ./vxdisksetup.ksh"\n\n" >> script_migration/README

echo 3.integration dans les DG >> script_migration/README
echo ./insertDisk.ksh"\n\n" >> script_migration/README

echo 4 mirroring des volumes >> script_migration/README
echo ./mirror.ksh"\n\n" >> script_migration/README

echo Attendre la fin de la migration vxtask list >> script_migration/README

echo 5. suppression des plex sur les anciens disques >> script_migration/README
echo ./rmPlex.ksh"\n\n" >> script_migration/README

echo 6. suppression des disques du system >> script_migration/README
echo ./rmdisk.ksh >> script_migration/README

